package com.ccnode.codegenerator.dom;

package .tmp;

import com.ccnode.codegenerator.dom.b;
import com.ccnode.codegenerator.dom.model.Association;
import com.ccnode.codegenerator.dom.model.Collection;
import com.ccnode.codegenerator.dom.model.ParameterMap;
import com.ccnode.codegenerator.dom.model.ResultMap;
import com.google.common.base.Optional;
import com.intellij.psi.PsiClass;
import com.intellij.psi.PsiElement;
import com.intellij.psi.util.PsiTreeUtil;
import com.intellij.psi.xml.XmlAttributeValue;
import com.intellij.psi.xml.XmlElement;
import com.intellij.psi.xml.XmlTag;
import com.intellij.util.xml.DomElement;
import com.intellij.util.xml.DomUtil;
import kotlin.Metadata;
import kotlin.jvm.internal.DefaultConstructorMarker;
import kotlin.jvm.internal.Intrinsics;
import org.jetbrains.annotations.NotNull;

@Metadata(mv = {1, 9, 0}, k = 1, xi = 48, d1 = {"\000.\n\002\030\002\n\002\020\000\n\002\b\002\n\002\030\002\n\002\030\002\n\000\n\002\030\002\n\000\n\002\020\013\n\000\n\002\030\002\n\000\n\002\030\002\n\000\b\003\030\0002\0020\001B\007\b\002¢\006\002\020\002J\024\020\003\032\b\022\004\022\0020\0050\0042\006\020\006\032\0020\007J\026\020\b\032\0020\t2\006\020\n\032\0020\0132\006\020\f\032\0020\r¨\006\016"}, d2 = {"Lcom/ccnode/codegenerator/dom/MapperBacktrackingUtils$Companion;", "", "()V", "getPropertyClazz", "Lcom/google/common/base/Optional;", "Lcom/intellij/psi/PsiClass;", "attributeValue", "Lcom/intellij/psi/xml/XmlAttributeValue;", "isWithinSameTag", "", "domElement", "Lcom/intellij/util/xml/DomElement;", "xmlElement", "Lcom/intellij/psi/xml/XmlElement;", "MyBatisCodeHelper-Pro241"})
public final class a {
  private a() {}
  
  @NotNull
  public final Optional<PsiClass> a(@NotNull XmlAttributeValue paramXmlAttributeValue) {
    DomElement domElement1;
    Intrinsics.checkNotNullParameter(paramXmlAttributeValue, "");
    if (DomUtil.getDomElement((PsiElement)paramXmlAttributeValue) == null) {
      DomUtil.getDomElement((PsiElement)paramXmlAttributeValue);
      Intrinsics.checkNotNullExpressionValue(Optional.absent(), "");
      return (Optional)Optional.absent();
    } 
    DomElement domElement2 = domElement1.getParent();
    while (domElement2 != null) {
      if (domElement2 instanceof Collection && 
        !a(domElement2, (XmlElement)paramXmlAttributeValue)) {
        Intrinsics.checkNotNullExpressionValue(Optional.fromNullable(((Collection)domElement2).getOfType().getValue()), "");
        return Optional.fromNullable(((Collection)domElement2).getOfType().getValue());
      } 
      if (domElement2 instanceof Association && 
        !a(domElement2, (XmlElement)paramXmlAttributeValue)) {
        Intrinsics.checkNotNullExpressionValue(Optional.fromNullable(((Association)domElement2).getJavaType().getValue()), "");
        return Optional.fromNullable(((Association)domElement2).getJavaType().getValue());
      } 
      if (domElement2 instanceof ParameterMap && 
        !a(domElement2, (XmlElement)paramXmlAttributeValue)) {
        Intrinsics.checkNotNullExpressionValue(Optional.fromNullable(((ParameterMap)domElement2).getType().getValue()), "");
        return Optional.fromNullable(((ParameterMap)domElement2).getType().getValue());
      } 
      if (domElement2 instanceof ResultMap && 
        !a(domElement2, (XmlElement)paramXmlAttributeValue)) {
        Intrinsics.checkNotNullExpressionValue(Optional.fromNullable(((ResultMap)domElement2).getType().getValue()), "");
        return Optional.fromNullable(((ResultMap)domElement2).getType().getValue());
      } 
      domElement2 = domElement2.getParent();
    } 
    Intrinsics.checkNotNullExpressionValue(Optional.absent(), "");
    return (Optional)Optional.absent();
  }
  
  public final boolean a(@NotNull DomElement paramDomElement, @NotNull XmlElement paramXmlElement) {
    Intrinsics.checkNotNullParameter(paramDomElement, "");
    Intrinsics.checkNotNullParameter(paramXmlElement, "");
    XmlTag xmlTag = (XmlTag)PsiTreeUtil.getParentOfType((PsiElement)paramXmlElement, XmlTag.class);
    return Intrinsics.areEqual(paramDomElement.getXmlTag(), xmlTag);
  }
}
